#define maxN 100000 //    N

#include <stdio.h>
#include <vector>

using namespace std;

vector<pair<int, bool> > edges[maxN];   //   edges[k]   ,      k.  ,  k    ,     true;  ,  k  ,  false
int left[maxN], right[maxN];    //  left[k]  right[k]   ,           k (     k  ,    -1)

int main()
{
    freopen("permutation.dat", "r", stdin);
    freopen("permutation.sol", "w", stdout);

    int N, M;
    scanf("%d %d", &N, &M);

    for (int i = 0; i < M; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        a--;    //   :    ,      
        b--;
        edges[a].push_back(make_pair(b, true));
        edges[b].push_back(make_pair(a, false));
    }

    for (int i = 0; i < N; i++) //   left  right
        left[i] = right[i] = -1;

    vector<int> order;  // ,    ,    ;      
    order.push_back(0); // ,       ,   1 (    ,    0)
    int currentIndex = 0;   // ,          
    while (currentIndex < order.size()) //       
    {
        int current = order[currentIndex];  // ,     
        currentIndex++; //       
        for (int i = 0; i < edges[current].size(); i++) //       
        {
            int added = edges[current][i].first;    //    
            if (left[added] == -1 && right[added] == -1)    // ֳ      ,       
            {
                order.push_back(added); //       
                if (edges[current][i].second)   //  ,       
                {                               //      :
                    left[added] = current;      // ˳     
                    right[added] = right[current];  //      ,     
                    if (right[added] != -1)     //     ,      
                        left[right[added]] = added;
                    right[current] = added;     // ,      
                } else                          //  ,       
                {                               //   䳿
                    right[added] = current;
                    left[added] = left[current];
                    if (left[added] != -1)
                        right[left[added]] = added;
                    left[current] = added;
                }
            }
        }
    }

    if (order.size() == N)  //     
    {
        int current = 0;    //       :   
        while (left[current] != -1) //  ,     
            current = left[current];
        printf("%d", current + 1);    //    
        while (right[current] != -1)  //    ,       
        {
            current = right[current];
            printf(" %d", current + 1); //      
        }
        printf("\n");
        for (int i = order.size() - 1; i > 0; i--)  //    ,   (    order[0])
            printf(i > 1 ? "%d " : "%d\n", order[i] + 1);   //      
    } else                  //      ,   
        printf("0\n");

    return 0;
}
