#define maxN 100000

#include <stdio.h>
#include <vector>

using namespace std;

vector<pair<int, bool> > edges[maxN];
bool visited[maxN];

int main()
{
    freopen("permutation.dat", "r", stdin);
    freopen("permutation.sol", "w", stdout);

    int N, M;
    scanf("%d %d", &N, &M);

    for (int i = 0; i < M; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        a--;
        b--;
        edges[a].push_back(make_pair(b, true));
        edges[b].push_back(make_pair(a, false));
    }

    for(int i = 0; i < N; i++)
        visited[i] = false;
    visited[0] = true;
    vector<int> permutation;
    permutation.push_back(0);
    vector<int> order;
    order.push_back(0);
    int currentIndex = 0;
    while (currentIndex < order.size())
    {
        int current = order[currentIndex];
        currentIndex++;
        int currentPosition = 0;
        while (permutation[currentPosition] != current)
            currentPosition++;
        for (int i = 0; i < edges[current].size(); i++)
        {
            int added = edges[current][i].first;
            if (! visited[added])
            {
                visited[added] = true;
                order.push_back(added);
                permutation.push_back(-1);
                for (int j = permutation.size() - 1; j > currentPosition + 1; j--)
                    permutation[j] = permutation[j - 1];
                if (edges[current][i].second)
                    permutation[currentPosition + 1] = added;
                else
                {
                    currentPosition++;
                    permutation[currentPosition] = current;
                    permutation[currentPosition - 1] = added;
                }
            }
        }
    }

    if (permutation.size() == N)
    {
        for (int i = 0; i < N; i++)
            printf(i < N - 1 ? "%d " : "%d\n", permutation[i] + 1);
        for (int i = order.size() - 1; i > 0; i--)
            printf(i > 1 ? "%d " : "%d\n", order[i] + 1);
    } else
        printf("0\n");

    return 0;
}
