#define maxN 100000
#define maxM 100000

#include <stdio.h>

int N, M, a[maxM], b[maxM], permutation[maxN], order[maxN], permutation_leftovers[maxN];
bool permutation_b[maxN + 1], order_b[maxN + 1];

bool findPair(int first, int second)
{
    for (int i = 0; i < M; i++)
        if (a[i] == first && b[i] == second)
            return true;
    return false;
}

bool runCheck()
{
    for (int i = 0; i < N; i++)
        permutation_leftovers[i] = permutation[i];
    for (int i = 0; i < N - 1; i++)
    {
        int cnt = 0;
        while (permutation_leftovers[cnt] != order[i])
            cnt++;
        if (cnt > 0 && findPair(permutation_leftovers[cnt - 1], permutation_leftovers[cnt]) || cnt < N - i - 1 && findPair(permutation_leftovers[cnt], permutation_leftovers[cnt + 1]))
            while (cnt < N - i - 1)
            {
                permutation_leftovers[cnt] = permutation_leftovers[cnt + 1];
                cnt++;
            }
        else
            return false;
    }
    return true;
}

bool runOrder(int step)
{
    if (step == N - 1)
        return runCheck();
    else
    {
        for (int i = 1; i <= N; i++)
            if (! order_b[i])
            {
                order[step] = i;
                order_b[i] = true;
                if (runOrder(step + 1))
                    return true;
                order_b[i] = false;
            }
        return false;
    }
}

bool runPermutation(int step)
{
    if (step == N)
        return runOrder(0);
    else
    {
        for (int i = 1; i <= N; i++)
            if (! permutation_b[i])
            {
                permutation[step] = i;
                permutation_b[i] = true;
                if (runPermutation(step + 1))
                    return true;
                permutation_b[i] = false;
            }
        return false;
    }
}

int main()
{
    freopen("permutation.dat", "r", stdin);
    freopen("permutation.sol", "w", stdout);

    scanf("%d %d", &N, &M);

    for (int i = 0; i < M; i++)
        scanf("%d %d", &a[i], &b[i]);

    for (int i = 1; i <= N; i++)
        permutation_b[i] = order_b[i] = false;

    if (runPermutation(0))
    {
        for (int i = 0; i < N; i++)
            printf(i < N - 1 ? "%d " : "%d\n", permutation[i]);
        for (int i = 0; i < N - 1; i++)
            printf(i < N - 2 ? "%d " : "%d\n", order[i]);
    } else
        printf("0\n");

    return 0;
}
