#define maxN 100000 //    N

#include <stdio.h>
#include <vector>

using namespace std;

vector<pair<int, bool> > edges[maxN];   //   edges[k]   ,      k.  ,  k    ,     true;  ,  k  ,  false
vector<int> permutation;    // -
vector<int> order;          // ,     
int visited[maxN]; // ,       ,  -1,       

//   : v   , depth   
void dfs(int v, int depth)
{
    int i;
    visited[v] = depth;

    for (i = 0; i < edges[v].size(); i++)   //       
        if (! edges[v][i].second && visited[edges[v][i].first] == -1)   //            
            dfs(edges[v][i].first, depth + 1); // 

    for (i = edges[v].size() - 1; i >= 0; i--)   //     order ,     ,    
        if (! edges[v][i].second && visited[edges[v][i].first] == depth + 1)
            order.push_back(edges[v][i].first);

    permutation.push_back(v);   //             

    for (i = 0; i < edges[v].size(); i++)   //       
        if (edges[v][i].second && visited[edges[v][i].first] == -1)   //            
        {
            dfs(edges[v][i].first, depth + 1); // 
            order.push_back(edges[v][i].first); //        order    ,     ,    
        }
}

int main()
{
    freopen("permutation.dat", "r", stdin);
    freopen("permutation.sol", "w", stdout);

    int N, M;
    scanf("%d %d", &N, &M);

    for (int i = 0; i < M; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        a--;    //   :    ,      
        b--;
        edges[a].push_back(make_pair(b, true));
        edges[b].push_back(make_pair(a, false));
    }

    for (int i = 0; i < N; i++) //   visited
        visited[i] = -1;
    dfs(0, 0); //         (     1, ,    ,   )

    if (permutation.size() == N)  //      
    {
        for (int i = 0; i < N; i++) //  -
            printf(i < N - 1 ? "%d " : "%d\n", permutation[i] + 1); //      
        for (int i = 0; i < N - 1; i++) //    ,  
            printf(i < N - 2 ? "%d " : "%d\n", order[i] + 1);   //      
    } else                  //       ,   
        printf("0\n");

    return 0;
}
